/*
 * UNICADO - UNIversity Conceptual Aircraft Design and Optimization
 *
 * Copyright (C) 2025 UNICADO consortium
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <https://www.gnu.org/licenses/>.
 *
 * Description:
 * This file is part of UNICADO.
 */

#include "laminarTAWCalculatePolar.h"
#include "HLFCStrategy.h"
#include "laminarTAWConfig.h"

#include <moduleBasics/strategySelector.h>
#include <moduleBasics/report.h>
#include <moduleBasics/plot.h>
#include <aixml/node.h>

#include <algorithm>
#include <memory>
#include <exception>
#include <iomanip>
#include <string>
#include <vector>
#include <utility>  // make_pair

#ifdef _WIN32
    #include <fileapi.h>
    #include <windows.h>
#endif  // _WIN32

using std::endl;
using std::exception;
using std::fixed;
using std::ofstream;
using std::setprecision;
using std::string;
using std::stringstream;
using std::vector;

void laminarTAWCalculatePolar::initialize() {
    myRuntimeInfo->out << "Calculate Polar for laminar TAW: Initialize..." << endl;
    config_ = std::make_shared<laminarTAWConfig>(rtIO_->moduleConfig);
    this->selectAeroStrategy();
    myHLFCStrategy = std::make_shared<HLFCStrategy>(rtIO_, config_);
}

void laminarTAWCalculatePolar::run() {
    myRuntimeInfo->out << "Calculate Polar for laminar TAW: Run..." << endl;

}

void laminarTAWCalculatePolar::update() {
    myRuntimeInfo->out << "Calculate Polar for laminar TAW: Update..." << endl;

}

void laminarTAWCalculatePolar::report() {
    myRuntimeInfo->out << "Calculate Polar for laminar TAW: Report..." << endl;

}

void laminarTAWCalculatePolar::save() {
    myRuntimeInfo->out << "Calculate Polar for laminar TAW: Save..." << endl;
}

void laminarTAWCalculatePolar::selectAeroStrategy() {
}