/*
 * UNICADO - UNIversity Conceptual Aircraft Design and Optimization
 *
 * Copyright (C) 2025 UNICADO consortium
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <https://www.gnu.org/licenses/>.
 *
 * Description:
 * This file is part of UNICADO.
 */

#ifndef INITIALSIZING_SRC_TAW_READONLY_TAWREADONLY_H_  
#define INITIALSIZING_SRC_TAW_READONLY_TAWREADONLY_H_  

#include <memory>
#include <vector>
#include <moduleBasics/strategySelector.h>
#include <moduleBasics/report.h>
#include <moduleBasics/plot.h>
#include "../../initialSizing.h"
#include "../TawInitialSizingIOData.h"

class TawReadonly : public Strategy {
 public:
    explicit TawReadonly(std::shared_ptr<RuntimeIO> rtIO);
    ~TawReadonly() = default;
    void initialize();
    void run();
    void update();
    void report();
    void save();

 private:  // NOLINT
    std::shared_ptr<RuntimeIO> rtIO_;
    std::shared_ptr<TawInitialSizingIOData> data_;
    Report report_;
};

#endif // INITIALSIZING_SRC_TAW_READONLY_TAWREADONLY_H_
