/*
 * UNICADO - UNIversity Conceptual Aircraft Design and Optimization
 * 
 * Copyright (C) 2025 UNICADO consortium
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <https://www.gnu.org/licenses/>.
 *
 * Description:
 * This file is part of UNICADO.
 */
#ifndef PERFORMANCE_ASSESSMENT_SRC_TAW_DEFAULTMETHODS_PAYLOADRANGE_ABSTRACTPAYLOADRANGE_H_
#define PERFORMANCE_ASSESSMENT_SRC_TAW_DEFAULTMETHODS_PAYLOADRANGE_ABSTRACTPAYLOADRANGE_H_

#include <vector>

class abstractPayloadRange
{
 private:
    /* data */
 public:
    std::vector<double> Payload; /**< List of payloads (kg) */
    std::vector<double> Fuel; /**< List of fuel masses (kg) */
    std::vector<double> TOM; /**< List of take-off masses (kg) */
    std::vector<double> Range; /**< List of aircraft ranges (km) */

    virtual ~abstractPayloadRange() { }

    virtual void calcPayloadRange() = 0;
};



#endif  // PERFORMANCE_ASSESSMENT_SRC_TAW_DEFAULTMETHODS_PAYLOADRANGE_ABSTRACTPAYLOADRANGE_H_
