/*
 * UNICADO - UNIversity Conceptual Aircraft Design and Optimization
 *
 * Copyright (C) 2025 UNICADO consortium
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <https://www.gnu.org/licenses/>.
 *
 * Description:
 * This file is part of UNICADO.
 */

#ifndef DIHEDRAL_METHODS_H_
#define DIHEDRAL_METHODS_H_

#include <iostream>
#include <tuple>

using modes = std::string;

namespace user_defined {
double dihedral(const double user_dihedral);
}

namespace by_wing_position_and_quarter_chord_sweep {
double dihedral(const std::string& wing_position, const double quarter_chord_sweep, const double mach_design, const double raymer_range_value);
}  // namespace by_wing_position_and_quarter_chord_sweep
namespace raymer {
double dihedral_limitation(const std::string& wing_position, const double quarter_chord_sweep,
                                               const double mach, const double raymer_range_value);
}

double get_design_dihedral(modes dihedral_mode, const std::string& wing_mounting, const double user_dihedral,
                           const double quarter_chord_sweep, const double mach_design, const double raymer_range_value);

#endif  // DIHEDRAL_METHODS_H_
