/*
 * UNICADO - UNIversity Conceptual Aircraft Design and Optimization
 *
 * Copyright (C) 2025 UNICADO consortium
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <https://www.gnu.org/licenses/>.
 *
 * Description:
 * This file is part of UNICADO.
 */

#ifndef SWEEP_ANGLE_METHODS_H_
#define SWEEP_ANGLE_METHODS_H_
#include <iostream>
using modes = std::string;
namespace user_defined {
double sweep_angle_at_quarter_chord(const double user_sweep_angle_at_quarter_chord);
}
namespace drag_divergence {
double sweep_angle_at_quarter_chord(const double mach_design, const double design_altitude,
                                    const double delta_drag_divergence, const double technology_factor_drag_divergence,
                                    const double max_thickness_to_chord_ratio, const double wing_loading);
}

double get_wing_quarter_chord_sweep(modes quarter_chord_sweep_mode, const double user_quarter_chord_sweep,
                                    const double mach_ica, const double wing_loading, const double design_altitude,
                                    const double max_thickness_to_chord_ratio, const double delta_drag_divergence,
                                    const double technology_factor_drag_divergence);

#endif  // SWEEP_ANGLE_METHODS_H_
